diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.42/src/wifi/test/spectrum-wifi-phy-test.cc	2024-05-29 15:29:47.216073800 -0700
+++ ns-3.43/src/wifi/test/spectrum-wifi-phy-test.cc	2024-10-09 16:41:10.136656800 -0700
@@ -858,18 +1634,17 @@
     void SwitchChannel(Ptr<SpectrumWifiPhy> phy,
                        WifiPhyBand band,
                        uint8_t channelNumber,
-                       uint16_t channelWidth,
+                       MHz_u channelWidth,
                        std::optional<std::size_t> listenerIndex);
 
     /**
      * Send PPDU function
      *
      * \param phy the PHY to transmit the signal
-     * \param txPowerDbm the power in dBm to transmit the signal (this is also the received power
-     * since we do not have propagation loss to simplify)
-     * \param payloadSize the payload size in bytes
+     * \param txPower the power to transmit the signal (this is also the received power since we do
+     * not have propagation loss to simplify) \param payloadSize the payload size in bytes
      */
-    void SendPpdu(Ptr<SpectrumWifiPhy> phy, double txPowerDbm, uint32_t payloadSize);
+    void SendPpdu(Ptr<SpectrumWifiPhy> phy, dBm_u txPower, uint32_t payloadSize);
 
     /**
      * Callback triggered when a packet is received by a PHY
@@ -933,8 +1708,8 @@
      * \param expectedRxBytes the expected amount of received bytes
      * \param expectedFrequencyRangeActiveRfInterface the expected frequency range (in MHz) of the
      * active RF interface
-     * \param expectedConnectedPhysPerChannel the expected
-     * number of PHYs attached for each spectrum channel
+     * \param expectedConnectedPhysPerChannel the expected number of PHYs attached for each spectrum
+     * channel
      */
     void CheckResults(std::size_t index,
                       uint32_t expectedNumRx,
@@ -1005,7 +1780,7 @@
 SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel(Ptr<SpectrumWifiPhy> phy,
                                                      WifiPhyBand band,
                                                      uint8_t channelNumber,
-                                                     uint16_t channelWidth,
+                                                     MHz_u channelWidth,
                                                      std::optional<std::size_t> listenerIndex)
 {
     NS_LOG_FUNCTION(this << phy << band << +channelNumber << channelWidth);
@@ -1026,14 +1801,22 @@
 
 void
 SpectrumWifiPhyMultipleInterfacesTest::SendPpdu(Ptr<SpectrumWifiPhy> phy,
-                                                double txPowerDbm,
+                                                dBm_u txPower,
                                                 uint32_t payloadSize)
 {
-    NS_LOG_FUNCTION(this << phy << txPowerDbm << payloadSize << phy->GetCurrentFrequencyRange()
+    NS_LOG_FUNCTION(this << phy << txPower << payloadSize << phy->GetCurrentFrequencyRange()
                          << phy->GetChannelWidth() << phy->GetChannelNumber());
 
-    WifiTxVector txVector =
-        WifiTxVector(HePhy::GetHeMcs11(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, 20, false, false);
+    WifiTxVector txVector{HePhy::GetHeMcs11(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          20,
+                          false,
+                          false};
     Ptr<Packet> pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -1046,8 +1829,8 @@
     m_lastTxEnd = m_lastTxStart + WifiPhy::CalculateTxDuration({std::make_pair(SU_STA_ID, psdu)},
                                                                txVector,
                                                                phy->GetPhyBand());
-    phy->SetTxPowerStart(txPowerDbm);
-    phy->SetTxPowerEnd(txPowerDbm);
+    phy->SetTxPowerStart(txPower);
+    phy->SetTxPowerEnd(txPower);
     phy->Send(WifiConstPsduMap({std::make_pair(SU_STA_ID, psdu)}), txVector);
 }
 
@@ -1276,20 +2059,12 @@
     for (std::size_t i = 0; i < interfaces.size(); ++i)
     {
         auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
-        [[maybe_unused]] const auto [channel, frequency, channelWidth, type, band] =
-            (*WifiPhyOperatingChannel::FindFirst(interfaces.at(i).number,
-                                                 0,
-                                                 0,
-                                                 WIFI_STANDARD_80211be,
-                                                 interfaces.at(i).band));
-
         auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
         spectrumChannel->SetPropagationDelayModel(delayModel);
         std::ostringstream oss;
         oss << "{" << +interfaces.at(i).number << ", 0, " << interfaces.at(i).bandName << ", 0}";
         phyHelper.Set(i, "ChannelSettings", StringValue(oss.str()));
         phyHelper.AddChannel(spectrumChannel, interfaces.at(i).range);
-
         m_spectrumChannels.emplace_back(spectrumChannel);
     }
 
@@ -1374,7 +2149,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    const auto ccaEdThresholdDbm = -62.0; ///< CCA-ED threshold in dBm
+    const dBm_u ccaEdThreshold = -62.0; ///< CCA-ED threshold
     const auto txAfterChannelSwitchDelay =
         MicroSeconds((m_chanSwitchScenario == ChannelSwitchScenario::BEFORE_TX)
                          ? 250
@@ -1537,7 +2312,7 @@
     }
 
     // verify CCA indication when switching to a channel with an ongoing transmission
-    for (const auto txPowerDbm : {-60.0 /* above CCA-ED */, -70.0 /* below CCA-ED */})
+    for (const dBm_u txPower : {-60.0 /* above CCA-ED */, -70.0 /* below CCA-ED */})
     {
         for (std::size_t i = 0; i < 4; ++i)
         {
@@ -1550,9 +2325,9 @@
                                                        20,
                                                        WIFI_STANDARD_80211ax,
                                                        txPpduPhy->GetPhyBand());
-                for (uint16_t bw = txPpduPhy->GetChannelWidth(); bw >= 20; bw /= 2)
+                for (auto bw = txPpduPhy->GetChannelWidth(); bw >= 20; bw /= 2)
                 {
-                    [[maybe_unused]] const auto [channel, frequency, channelWidth, type, band] =
+                    const auto& channelInfo =
                         (*WifiPhyOperatingChannel::FindFirst(0,
                                                              0,
                                                              bw,
@@ -1564,15 +2339,15 @@
                                         &SpectrumWifiPhyMultipleInterfacesTest::SendPpdu,
                                         this,
                                         txPpduPhy,
-                                        txPowerDbm,
+                                        txPower,
                                         1000);
                     Simulator::Schedule(delay + txOngoingAfterTxStartedDelay,
                                         &SpectrumWifiPhyMultipleInterfacesTest::SwitchChannel,
                                         this,
                                         m_rxPhys.at(j),
-                                        band,
-                                        channel,
-                                        channelWidth,
+                                        channelInfo.band,
+                                        channelInfo.number,
+                                        channelInfo.width,
                                         j);
                     for (std::size_t k = 0; k < 4; ++k)
                     {
@@ -1581,9 +2356,9 @@
                             continue;
                         }
                         const auto expectCcaBusyIndication =
-                            (k == i) ? (txPowerDbm >= ccaEdThresholdDbm)
+                            (k == i) ? (txPower >= ccaEdThreshold)
                                      : (m_trackSignalsInactiveInterfaces
-                                            ? ((txPowerDbm >= ccaEdThresholdDbm) ? (j == k) : false)
+                                            ? ((txPower >= ccaEdThreshold) ? (j == k) : false)
                                             : false);
                         Simulator::Schedule(
                             delay + checkResultsDelay,
@@ -2009,11 +2784,14 @@
 };
 
 SpectrumWifiPhyTestSuite::SpectrumWifiPhyTestSuite()
-    : TestSuite("wifi-spectrum-wifi-phy", Type::UNIT)
+    : TestSuite("wifi-spectrum-phy", Type::UNIT)
 {
     AddTestCase(new SpectrumWifiPhyBasicTest, TestCase::Duration::QUICK);
     AddTestCase(new SpectrumWifiPhyListenerTest, TestCase::Duration::QUICK);
     AddTestCase(new SpectrumWifiPhyFilterTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyGetBandTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhyTrackedBandsTest, TestCase::Duration::QUICK);
+    AddTestCase(new SpectrumWifiPhy80Plus80Test, TestCase::Duration::QUICK);
     AddTestCase(new SpectrumWifiPhyMultipleInterfacesTest(
                     false,
                     SpectrumWifiPhyMultipleInterfacesTest::ChannelSwitchScenario::BEFORE_TX),
